<%@ Page Language="C#" Debug="false" Trace="false" EnableViewState="false" %>
<%@ import Namespace="System" %>
<%@ import Namespace="System.IO" %>
<%@ import Namespace="System.Xml" %>
<%@ import Namespace="System.Data" %>
<%@ import Namespace="System.Text" %>
<script runat="server">

    // ################ Settings ################
    const string COMIC_DIRECTORY = @"Comics\";

    void Page_Load (Object sender, EventArgs e)
    {
        if (Request.QueryString["comicid"] == null)
        { // List all available comics as XML
            
            ListAllComics();
        }
        else
        { // Load selected comic

            LoadComic(Convert.ToInt32(Request.QueryString["comicid"]));
        }
    }
    
    // Load selected comic
    void LoadComic(int iComicID)
    {
        XmlDocument xmlDoc = new XmlDocument();
        Trace.Write(Server.MapPath(COMIC_DIRECTORY) + iComicID.ToString() + ".xml");
        xmlDoc.Load( Server.MapPath(COMIC_DIRECTORY) + iComicID.ToString() + ".xml" );

        Response.ContentType = "text/xml";
        Response.Write(xmlDoc.OuterXml.ToString());
    }
    
    // List all available comics as XML
    void ListAllComics()
    {
        // Create XML return object
        StringWriter oStringWriter = new StringWriter();
        XmlTextWriter xmlComics = new XmlTextWriter(oStringWriter);

        xmlComics.WriteStartElement("comics");
        
        // Cycle through each comic
        DirectoryInfo di = new DirectoryInfo( Server.MapPath( COMIC_DIRECTORY ) );
        FileInfo[] rgFiles = di.GetFiles("*.xml");
        foreach (FileInfo fi in rgFiles)
        {
            // Load comic XML
            XmlDocument xmlDoc = new XmlDocument();
            xmlDoc.Load( fi.FullName );

            Trace.Write(fi.FullName);

            xmlComics.WriteStartElement("comic");
            
            XmlAttributeCollection oAttribute = xmlDoc.ChildNodes[1].Attributes;

            xmlComics.WriteAttributeString("comicid", fi.Name.ToLower().Replace( ".xml", string.Empty ) );
            xmlComics.WriteAttributeString("name", oAttribute.GetNamedItem("Name").Value.ToString() );
            xmlComics.WriteAttributeString("datePublish", oAttribute.GetNamedItem("DatePublish").Value.ToString());
            xmlComics.WriteAttributeString("dateCreated", oAttribute.GetNamedItem("DateCreated").Value.ToString());
            xmlComics.WriteAttributeString("dateModified", oAttribute.GetNamedItem("DateModified").Value.ToString());
            
            xmlComics.WriteEndElement();   
        }

        xmlComics.WriteEndElement();

        Response.ContentType = "text/xml";
        Response.Write(oStringWriter.ToString());  
    }
    
</script>